<?php
if (!defined('IN_PLP'))
{
	die('Hacking attempt');
	exit;
}

// == Functions
// sets the default vars, get vars and post vars
function set_vars()
{
	global $config;

	foreach ($config as $key => $val)
	{
		global $$key;
		$$key = isset($_REQUEST[$key]) ? $_REQUEST[$key] : set($val);
		$$key = clean_html($key, $$key);
	}
}

// loads, saves and deletes the cookie vars
function set_cookie_vars($action)
{
	global $config, $cookie_name, $cookie_lifetime, $cookie_path, $cookie_domain;

	$dont_save_vars = array('page', 'pass');

	if ($action == 'load')
	{
		if (!empty($_COOKIE[$cookie_name]))
		{
			$cookie_array = unserialize(base64_decode($_COOKIE[$cookie_name]));
			foreach ($cookie_array as $key => $val)
			{
				if (array_key_exists($key, $config) && !in_array($key, $dont_save_vars))
				{
					global $$key;
					$$key = clean_html($key, $val);
				}
			}
		}
		return;
	}

	if ($action == 'save')
	{
		foreach ($_REQUEST as $key => $val)
		{
			if (array_key_exists($key, $config) && !in_array($key, $dont_save_vars))
			{
				$cookie_array[$key] = clean_html($key, $val);
			}
		}

		if (isset($cookie_array))
		{
			$cookie_string = base64_encode(serialize($cookie_array));
			setcookie($cookie_name, $cookie_string, time()+$cookie_lifetime, $cookie_path, $cookie_domain);
		}
		return;
	}

	if ($action == 'delete')
	{
		setcookie($cookie_name, '', time()-$cookie_lifetime-1e3, $cookie_path, $cookie_domain);
		return;
	}
}

// makes values html conform
function clean_html($key, $value)
{
	//	if ($key == 'nick') $value = replace_umlauts($value);
	$trans_tbl = array_flip(get_html_translation_table(HTML_ENTITIES));
	$value    = htmlentities(strtr(strip_tags($value), $trans_tbl), ENT_QUOTES);

	return trim($value);
}

// formats HTML source code
function html($tab, $code, $br=1)
{
	$t = "";
	for ($i=0; $i<$tab; $i++) $t .= "\t";

	$n = "";
	for ($i=0; $i<$br; $i++) $n .= "\n";

	echo $t.$code.$n;
}

// creates query string for hyperlinks
function query_string($array=array())
{
	global $self;

	$s = '?';
	$query_string = $self;
	foreach ($array as $key => $val)
	{
		if ($val != '')
		{
			$query_string .= $s.$key.'='.urlencode($val);
			$s = '&amp;';
		}
	}

	return $query_string;
}

// replaces some signs, which some IRC Servers don't like
function replace_umlauts($string)
{
	$string = str_replace('', 'ae', $string);
	$string = str_replace('', 'oe', $string);
	$string = str_replace('', 'ue', $string);
	$string = str_replace('', 'Ae', $string);
	$string = str_replace('', 'Oe', $string);
	$string = str_replace('', 'Ue', $string);
	$string = str_replace('', 'ss', $string);
	$string = str_replace(' ', '_', $string);
	$string = preg_replace('/^[0-9]*[0-9]/', '', $string);

	return $string;
}

// string value to true/false
function set($var)
{
	if (strtolower($var) == 'yes') $var = TRUE;
	if (strtolower($var) == 'no') $var = FALSE;

	return $var;
}

// writes option values for select boxes, and detects which option should be selected
function selected($tab, $options, $active)
{
	foreach ($options as $key => $val)
	{
		$sel = '';
		if ($val == $active) $sel = ' selected="selected"';
		html($tab, '<option'.$sel.'>'.$val.'</option>');
	}
}

// calculates the cookie lifetime
function math_lifetime($string)
{
	list($number, $unit) = explode(' ', $string);
	switch ($unit)
	{
		case 'h':
			$math = 60;
			break;
		case 'd':
			$math = 60*24;
			break;
		case 'w':
			$math = 60*24*7;
			break;
		case 'm':
			$math = 60*24*7*30;
			break;
		default:
			$math = 1;
	}

	return $number*$math;
}

// my watermark ;)
function print_footer()
{
	define('PROJECT', 'PJIRC Login Page Version 5.0');

	html(0, '<table width="100%" cellspacing="0" cellpadding="0" class="invisible"><tr>');
	html(1, '<td align="left">'.PROJECT.'</td>');
	html(1, '<td align="center">&nbsp;</td>');
	html(1, '<td align="right">&copy;&nbsp;Manuel Thelen&nbsp;2004-'.date('Y').'</td>');
	html(0, '</tr></table>', 2);
}
?>